#! /bin/sh

# $1 file

file=$1
if [ -d $file ]; then exit; fi

case `basename $file` in
  *.c)    type=c;;
  *.cc)   type=c;;
  *.h)    type=c;;
  *.idl)  type=c;;
  *.java) type=java;;
  *.mk*)  type=mk;;
  Makefile*) type=mk;;
  *.doxygen) type=mk;;
  configure.in) type=m4;;
  *.sh*)  type=sh;;
  *.csh*) type=sh;;
  *.tex)  type=tex;;
  .*)     type=;;
  *)
    case "`head -1 $file`" in
      \#!*) type=sh ;;
      *) type=;;
    esac
esac

echo "${type}: `basename $file`"

case $type in
  c|java|mk|m4|tex)
    cp $file ${file}.tmp
    cat /tmp/COPYRIGHT.${type} ${file}.tmp > $file
    rm ${file}.tmp
  ;;
  sh)
    cp $file ${file}.tmp
    head -1 ${file}.tmp         > $file
    cat /tmp/COPYRIGHT.${type} >> $file
    tail +2 ${file}.tmp        >> $file
    rm ${file}.tmp
  ;;
  *)
  ;;
esac
