
.PHONY: clean-distrib release distrib maintainer-help

PM2_URL        = "svn+ssh://svn.gforge.inria.fr/svn/pm2/trunk"
PM2_EXPORT_DIR = $(PADICO_ROOT)/var/tmp/pm2-pkg
PM2_ARCHIVE    = opt/pm2/pm2.tar.gz
SVN            = svn

pm2-pkg:
	@( if [ -r $(PM2_EXPORT_DIR) ]; then cd $(PM2_EXPORT_DIR)/.. ; /bin/rm -rf pm2-pkg ; fi )
	mkdir -p $(PM2_EXPORT_DIR)
	@echo "- exporting PM2 from subversion..."
	$(SVN) export $(PM2_URL) $(PM2_EXPORT_DIR)/pm2
	( $(SVN) info $(PM2_URL) || ( echo $(PM2_URL) ; /bin/date ) ) > $(PM2_EXPORT_DIR)/pm2/REVISION
	@echo "---------------------------------------------"
	@cat $(PM2_EXPORT_DIR)/pm2/REVISION
	@echo "---------------------------------------------"
	@echo "- packing archive..."
	( ( cd $(PM2_EXPORT_DIR) ; tar --totals -cf - pm2 ) | gzip -9 - > $(PM2_ARCHIVE) )
	@echo "- cleaning..."
	( cd $(PM2_EXPORT_DIR)/.. ; /bin/rm -rf pm2-pkg )
	@echo "- done."

clean-distrib:
	@echo
	@echo "# Cleaning distrib temporary directory: $(PADICO_ROOT)/var/tmp/release"
	@echo
	/bin/rm -rf $(PADICO_ROOT)/var/tmp/release

distrib:
	./admin/mkdistrib.sh

release:
	@$(MAKE) clean-distrib
	@$(MAKE) distrib

maintainer-help:
	@echo "  pm2-pkg         make a package from a PM2 snapshot"
	@echo "  clean-distrib   clean the temporary distrib directory"
	@echo "  release         make release for publication"
	@echo "  distrib         make the actual packaging"

